package util

import (
	"github.com/shopspring/decimal"
	"strconv"
)

//FormatFloat64 将多余的浮点格式化
func FormatFloat64(f float64) string {
	return strconv.FormatFloat(f, 'f', -1, 64)
}

//FormatFloat32 将多余的浮点格式化
func FormatFloat32(f float32) string {
	return strconv.FormatFloat(float64(f), 'f', -1, 32)
}

// AddFloat64 精度加法 a+b
func AddFloat64(a *float64, b *float64) *float64 {
	//r, _ := new(big.Float).Add(new(big.Float).SetFloat64(*a), new(big.Float).SetFloat64(*b)).Float64()
	r, _ := decimal.NewFromFloat(*a).Add(decimal.NewFromFloat(*b)).Float64()
	return &r
}

// SubtractFloat64 精度减法 a-b
func SubtractFloat64(a *float64, b *float64) *float64 {
	//r, _ := new(big.Float).Sub(new(big.Float).SetFloat64(*a), new(big.Float).SetFloat64(*b)).Float64()
	r, _ := decimal.NewFromFloat(*a).Sub(decimal.NewFromFloat(*b)).Float64()
	return &r
}

// MultiplyFloat64 精度乘法 axb
func MultiplyFloat64(a *float64, b *float64) *float64 {
	//r, _ := new(big.Float).Mul(new(big.Float).SetFloat64(*a), new(big.Float).SetFloat64(*b)).Float64()
	r, _ := decimal.NewFromFloat(*a).Mul(decimal.NewFromFloat(*b)).Float64()
	return &r
}

// DivideFloat64 精度除法 a/b
func DivideFloat64(a *float64, b *float64) *float64 {
	//r, _ := new(big.Float).Quo(new(big.Float).SetFloat64(*a), new(big.Float).SetFloat64(*b)).Float64()
	r, _ := decimal.NewFromFloat(*a).Div(decimal.NewFromFloat(*b)).Float64()
	return &r
}
